using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Movie
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Movie : System.Windows.Forms.Form
	{
		public System.Windows.Forms.ComboBox NameList;
		private System.Windows.Forms.Label Person_lbl;
		private System.Windows.Forms.Label MovieList;
		private System.Windows.Forms.Button Checkout_btn;
		private System.Windows.Forms.Button Return_btn;
		public System.Windows.Forms.ListBox MovieListBox;
		public System.Data.OleDb.OleDbConnection conn;
		private System.Data.OleDb.OleDbDataReader dreader;
		private System.Data.OleDb.OleDbCommand oleDbCommand;
		private System.Windows.Forms.ListBox MovieOutBox;
		private System.Windows.Forms.DateTimePicker dateTimePicker;
		private System.Windows.Forms.CheckBox DeleteReturnBox;
		private System.Windows.Forms.Button Refresh_btn;
		private System.Windows.Forms.Button Add_btn;
		private Info Info;
		private System.Windows.Forms.Label CheckoutList;
		private System.Windows.Forms.Button Delete_btn;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Movie()
		{
			InitializeComponent();

			MovieListBox.SelectionMode = SelectionMode.MultiExtended;
			MovieOutBox.SelectionMode = SelectionMode.MultiExtended;

			LoadNames();

			LoadList();
			DeleteReturnBox.Checked = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}



		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Movie));
			this.NameList = new System.Windows.Forms.ComboBox();
			this.Person_lbl = new System.Windows.Forms.Label();
			this.MovieList = new System.Windows.Forms.Label();
			this.MovieListBox = new System.Windows.Forms.ListBox();
			this.Checkout_btn = new System.Windows.Forms.Button();
			this.Return_btn = new System.Windows.Forms.Button();
			this.conn = new System.Data.OleDb.OleDbConnection();
			this.oleDbCommand = new System.Data.OleDb.OleDbCommand();
			this.MovieOutBox = new System.Windows.Forms.ListBox();
			this.dateTimePicker = new System.Windows.Forms.DateTimePicker();
			this.DeleteReturnBox = new System.Windows.Forms.CheckBox();
			this.Refresh_btn = new System.Windows.Forms.Button();
			this.Add_btn = new System.Windows.Forms.Button();
			this.CheckoutList = new System.Windows.Forms.Label();
			this.Delete_btn = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// NameList
			// 
			this.NameList.Location = new System.Drawing.Point(16, 40);
			this.NameList.Name = "NameList";
			this.NameList.Size = new System.Drawing.Size(192, 21);
			this.NameList.TabIndex = 0;
			this.NameList.SelectedIndexChanged += new System.EventHandler(this.NameList_SelectedIndexChanged);
			// 
			// Person_lbl
			// 
			this.Person_lbl.Location = new System.Drawing.Point(16, 16);
			this.Person_lbl.Name = "Person_lbl";
			this.Person_lbl.Size = new System.Drawing.Size(56, 16);
			this.Person_lbl.TabIndex = 1;
			this.Person_lbl.Text = "Person:";
			// 
			// MovieList
			// 
			this.MovieList.Location = new System.Drawing.Point(16, 88);
			this.MovieList.Name = "MovieList";
			this.MovieList.Size = new System.Drawing.Size(96, 23);
			this.MovieList.TabIndex = 2;
			this.MovieList.Text = "Available Movies:";
			// 
			// MovieListBox
			// 
			this.MovieListBox.Location = new System.Drawing.Point(16, 112);
			this.MovieListBox.Name = "MovieListBox";
			this.MovieListBox.Size = new System.Drawing.Size(192, 238);
			this.MovieListBox.TabIndex = 3;
			// 
			// Checkout_btn
			// 
			this.Checkout_btn.Location = new System.Drawing.Point(226, 192);
			this.Checkout_btn.Name = "Checkout_btn";
			this.Checkout_btn.Size = new System.Drawing.Size(32, 23);
			this.Checkout_btn.TabIndex = 4;
			this.Checkout_btn.Text = ">>";
			this.Checkout_btn.Click += new System.EventHandler(this.Checkout_btn_Click);
			// 
			// Return_btn
			// 
			this.Return_btn.Location = new System.Drawing.Point(226, 232);
			this.Return_btn.Name = "Return_btn";
			this.Return_btn.Size = new System.Drawing.Size(32, 23);
			this.Return_btn.TabIndex = 5;
			this.Return_btn.Text = "<<";
			this.Return_btn.Click += new System.EventHandler(this.Return_btn_Click);
			// 
			// conn
			// 
			this.conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=movie.mdb";
			// 
			// oleDbCommand
			// 
			this.oleDbCommand.Connection = this.conn;
			// 
			// MovieOutBox
			// 
			this.MovieOutBox.Location = new System.Drawing.Point(280, 112);
			this.MovieOutBox.Name = "MovieOutBox";
			this.MovieOutBox.Size = new System.Drawing.Size(208, 238);
			this.MovieOutBox.TabIndex = 6;
			// 
			// dateTimePicker
			// 
			this.dateTimePicker.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dateTimePicker.Location = new System.Drawing.Point(280, 16);
			this.dateTimePicker.Name = "dateTimePicker";
			this.dateTimePicker.Size = new System.Drawing.Size(88, 20);
			this.dateTimePicker.TabIndex = 7;
			// 
			// DeleteReturnBox
			// 
			this.DeleteReturnBox.Location = new System.Drawing.Point(280, 56);
			this.DeleteReturnBox.Name = "DeleteReturnBox";
			this.DeleteReturnBox.Size = new System.Drawing.Size(160, 16);
			this.DeleteReturnBox.TabIndex = 8;
			this.DeleteReturnBox.Text = "Delete Returned Records";
			// 
			// Refresh_btn
			// 
			this.Refresh_btn.Location = new System.Drawing.Point(216, 280);
			this.Refresh_btn.Name = "Refresh_btn";
			this.Refresh_btn.Size = new System.Drawing.Size(56, 23);
			this.Refresh_btn.TabIndex = 9;
			this.Refresh_btn.Text = "Refresh";
			this.Refresh_btn.Click += new System.EventHandler(this.Refresh_btn_Click);
			// 
			// Add_btn
			// 
			this.Add_btn.Location = new System.Drawing.Point(432, 16);
			this.Add_btn.Name = "Add_btn";
			this.Add_btn.Size = new System.Drawing.Size(56, 24);
			this.Add_btn.TabIndex = 10;
			this.Add_btn.Text = "Add";
			this.Add_btn.Click += new System.EventHandler(this.Add_btn_Click);
			// 
			// CheckoutList
			// 
			this.CheckoutList.Location = new System.Drawing.Point(280, 88);
			this.CheckoutList.Name = "CheckoutList";
			this.CheckoutList.Size = new System.Drawing.Size(112, 23);
			this.CheckoutList.TabIndex = 11;
			this.CheckoutList.Text = "Checked Out Movies:";
			// 
			// Delete_btn
			// 
			this.Delete_btn.Location = new System.Drawing.Point(432, 48);
			this.Delete_btn.Name = "Delete_btn";
			this.Delete_btn.Size = new System.Drawing.Size(56, 23);
			this.Delete_btn.TabIndex = 12;
			this.Delete_btn.Text = "Delete";
			this.Delete_btn.Click += new System.EventHandler(this.Delete_btn_Click);
			// 
			// Movie
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 366);
			this.Controls.Add(this.Delete_btn);
			this.Controls.Add(this.CheckoutList);
			this.Controls.Add(this.Add_btn);
			this.Controls.Add(this.Refresh_btn);
			this.Controls.Add(this.DeleteReturnBox);
			this.Controls.Add(this.dateTimePicker);
			this.Controls.Add(this.MovieOutBox);
			this.Controls.Add(this.Return_btn);
			this.Controls.Add(this.Checkout_btn);
			this.Controls.Add(this.MovieListBox);
			this.Controls.Add(this.MovieList);
			this.Controls.Add(this.Person_lbl);
			this.Controls.Add(this.NameList);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Movie";
			this.Text = "Movie Database 1.1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Movie());
		}

		private void LoadList()
		{
			try
			{
				MovieListBox.Items.Clear();
				//load movielistbox
				//"select movie_name from checkout where return_date='Null'
				oleDbCommand.CommandText = "select * from movie order by movie_name";
				oleDbCommand.CommandType = CommandType.Text;
				conn.Open();
				dreader = oleDbCommand.ExecuteReader();
				string s = "";
				while (dreader.Read())
				{
					s = dreader["movie_name"].ToString();
					MovieListBox.Items.Add(s);	
				}
				dreader.Close();
				conn.Close();

				//take out movies that are checked out
				oleDbCommand.CommandText = "select movie_name from checkout where return_date='Null'";
				oleDbCommand.CommandType = CommandType.Text;
				conn.Open();
				dreader = oleDbCommand.ExecuteReader();
				s = "";
				while (dreader.Read())
				{
					s = dreader["movie_name"].ToString();
					MovieListBox.Items.Remove(s);
						
				}
				dreader.Close();
				conn.Close();

			}
			catch (Exception ex)
			{
				MessageBox.Show("Failed to connect to data source.  " + ex.Message.ToString());
			}
			finally
			{
				conn.Close();
			}
		}

		private void LoadNames()
		{
			try
			{
				NameList.Items.Clear();
				//load namelist
				oleDbCommand.CommandText = "select * from person order by person_name";
				oleDbCommand.CommandType = CommandType.Text;
				conn.Open();
				dreader = oleDbCommand.ExecuteReader();
				string s = "All";
				NameList.Items.Add(s);

				while (dreader.Read())
				{
					s = dreader["person_name"].ToString();
					NameList.Items.Add(s);
							
				}
				dreader.Close();
				conn.Close();
				NameList.SelectedIndex=0;
				
			}
			catch (Exception ex)
			{
				MessageBox.Show("Failed to connect to data source.  " + ex.Message.ToString());
			}
			finally
			{
				conn.Close();
			}
		}

		private void Checkout_btn_Click(object sender, System.EventArgs e)
		{
			if(MovieListBox.SelectedIndices.Count > 0 && NameList.SelectedItem != null)
			{
				int indexCount = MovieListBox.SelectedIndices.Count;
				
				for(int i=0; i < indexCount; i++)
				{
					MovieOutBox.Items.Add(MovieListBox.Items[MovieListBox.SelectedIndices[i]].ToString());

					//update db
					try
					{
						conn.Open();					
						//MessageBox.Show(NameList.SelectedItem.ToString());
						oleDbCommand.CommandText = "insert into checkout (person_name, movie_name, checkout_date, return_date) values('"+NameList.SelectedItem.ToString()+"','"+ MovieListBox.Items[MovieListBox.SelectedIndices[i]].ToString() +"', '"+dateTimePicker.Value.Date.ToShortDateString()+"','Null')";				
						oleDbCommand.CommandType = CommandType.Text;

						oleDbCommand.ExecuteNonQuery();			
						conn.Close();
					}
					catch (Exception ex)
					{
						MessageBox.Show(ex.Message.ToString());
					}
					finally
					{
						conn.Close();
					}
				}

				for(int i=indexCount-1; i >= 0; i--)
				{
					MovieListBox.Items.RemoveAt(MovieListBox.SelectedIndices[i]);

				}
				//save db info
			}
			else
			{
				MessageBox.Show("There is either no movie or no person selected");
			}
		}

		private void Return_btn_Click(object sender, System.EventArgs e)
		{
			if(MovieOutBox.SelectedIndices.Count > 0 && NameList.SelectedItem != null)
			{
				int indexCount = MovieOutBox.SelectedIndices.Count;
			
				for(int i=0; i < indexCount; i++)
				{
					MovieListBox.Items.Add(MovieOutBox.Items[MovieOutBox.SelectedIndices[i]].ToString());

					//update db
					try
					{
						conn.Open();
						if(DeleteReturnBox.Checked)
						{
							oleDbCommand.CommandText = "delete from checkout where return_date ='Null' AND person_name='"+NameList.SelectedItem.ToString()+"'AND movie_name='"+ MovieOutBox.Items[MovieOutBox.SelectedIndices[i]].ToString() +"'";
						}
						else
						{
							oleDbCommand.CommandText = "update checkout set return_date ='"+dateTimePicker.Value.Date.ToShortDateString()+"' where person_name='"+NameList.SelectedItem.ToString()+"'AND movie_name='"+ MovieOutBox.Items[MovieOutBox.SelectedIndices[i]].ToString() +"'AND return_date ='Null'";
						}
						oleDbCommand.CommandType = CommandType.Text;

						oleDbCommand.ExecuteNonQuery();	
						
						conn.Close();
					}
					catch (Exception ex)
					{
						MessageBox.Show(ex.Message.ToString());
					}
					finally
					{
						conn.Close();
					}
				}

				for(int i=indexCount-1; i >= 0; i--)
				{
					MovieOutBox.Items.RemoveAt(MovieOutBox.SelectedIndices[i]);

				}
				//MessageBox.Show(dateTimePicker.Value.Date.ToShortDateString());

				
			}
			else
			{
				MessageBox.Show("There is either no movie or no person selected");	
			}
		}

		private void NameList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				
				//MessageBox.Show(NameList.SelectedItem.ToString());
				if(NameList.SelectedItem.ToString() =="All")
				{
					oleDbCommand.CommandText = "select * from checkout where return_date='Null' order by movie_name";
				}
				else
				{
					oleDbCommand.CommandText = "select * from checkout where person_name='"+NameList.SelectedItem.ToString()+"'AND return_date='Null' order by movie_name";
				}

				oleDbCommand.CommandType = CommandType.Text;
				conn.Open();
				dreader = oleDbCommand.ExecuteReader();
				string s = "";
				MovieOutBox.Items.Clear();
				while (dreader.Read())
				{
					s = dreader["movie_name"].ToString();
					MovieOutBox.Items.Add(s);
							
				}
				dreader.Close();
				conn.Close();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Failed to connect to data source.  " + ex.Message.ToString());
			}
			finally
			{
				conn.Close();
			}
		}

		private void Refresh_btn_Click(object sender, System.EventArgs e)
		{
			LoadList();
			LoadNames();
		}

		private void Add_btn_Click(object sender, System.EventArgs e)
		{
			Info = new Info(conn, true, this);
			Info.ShowDialog();
			Refresh_btn_Click(sender, e);
		}

		private void Delete_btn_Click(object sender, System.EventArgs e)
		{
			Info = new Info(conn, false, this);
			Info.ShowDialog();
			Refresh_btn_Click(sender, e);
		
		}

	}
}
